## notion 3+2017050501

=== Makefile ===
##
## Notion Makefile
##

# Include system-specific configuration: auto-generated and optionally local 
include build/system-inc.mk

# List of modules
include modulelist.mk

######################################

INSTALL_SUBDIRS=\
	$(MODULE_LIST) \
	ioncore notion etc utils man po contrib/scripts

SUBDIRS = $(LIBS_SUBDIRS) $(INSTALL_SUBDIRS)

DOCS = README.md LICENSE CHANGELOG

TO_REALCLEAN = build/ac/system-ac.mk

POTFILE=po/notion.pot

######################################

include build/rules.mk

######################################

_install:
	$(INSTALLDIR) $(DESTDIR)$(DOCDIR)
	for i in $(DOCS); do \
		$(INSTALL) -m $(DATA_MODE) $$i $(DESTDIR)$(DOCDIR); \
	done

relocatable_build:
	$(MAKE) RELOCATABLE=1 PREFIX=

snapshot:
	PWD=`pwd` ;\
	DIR=`basename "$$PWD"` ;\
	RELEASE=`./nextversion.sh`-snapshot ;\
	perl -p -i -e "s/^#define NOTION_RELEASE.*/#define NOTION_RELEASE \"$$RELEASE\"/" version.h ;\
	cd .. ;\
	tar --exclude-vcs -czf notion-$$RELEASE-src.tar.gz $$DIR ;\
	tar --exclude-vcs -cjf notion-$$RELEASE-src.tar.bz2 $$DIR ;\
	cd $$DIR ;\
	git checkout version.h

dist:
	PWD=`pwd` ;\
	DIR=`basename "$$PWD"` ;\
	RELEASE=`./nextversion.sh` ;\
	perl -p -i -e "s/^#define NOTION_RELEASE.*/#define NOTION_RELEASE \"$$RELEASE\"/" version.h ;\
	git add version.h; git commit -m "Releasing version $$RELEASE" ;\
	git tag -s -m "Release $$RELEASE" $$RELEASE ; git push --tags ;\
	git archive --prefix notion-$$RELEASE/ --format=tar.gz $$RELEASE > ../notion-$$RELEASE-src.tar.gz ;\
	git archive --prefix notion-$$RELEASE/ --format=tar $$RELEASE | bzip2 > ../notion-$$RELEASE-src.tar.bz2 ;\
	perl -p -i -e "s/^#define NOTION_RELEASE.*/#define NOTION_RELEASE \"snapshot\"/" version.h ;\
	git add version.h; git commit -m "Released version $$RELEASE" ; git push 

.PHONY: test

test:
	$(MAKE) -C mod_xrandr test
	$(MAKE) -C mod_xinerama test
	$(MAKE) -C test

=== man/Makefile ===
##
## Notion manual page Makefile
##

# System-specific configuration is in system.mk
TOPDIR=..
include $(TOPDIR)/build/system-inc.mk

######################################

TRANSLATIONS=fi cs

WELCOME_TARGETS=\
	welcome.txt \
	$(foreach tr, $(TRANSLATIONS), welcome.$(tr).txt)

TARGETS=notion.1 notionflux.1 $(foreach tr, $(TRANSLATIONS), notion.$(tr).1) \
	$(WELCOME_TARGETS)

MKMAN=$(LUA) ../build/mkman.lua $(MKMAN_DEFS)
MKMAN_DEFS=-D ETCDIR $(REL)$(ETCDIR) -D DOCDIR $(REL)$(DOCDIR)

ifeq ($(RELOCATABLE),1)
REL="/..."
endif

NROFF=nroff -man -Tlatin1
#FILTERCRAP=perl -p -i -e 's/.\10//g'
FILTERCRAP=$(LUA) -e 'io.write((string.gsub(io.read("*a"), ".\8", "")))'

CONFIGS=../etc/cfg_notioncore.lua \
	../etc/cfg_tiling.lua \
	../etc/cfg_query.lua \
	../etc/cfg_menu.lua

######################################

include $(TOPDIR)/build/rules.mk

######################################

notion.1: notion.in $(CONFIGS)
	$(MKMAN) -i $< -o $@ $(CONFIGS)

notion.%.1: notion.%.in $(CONFIGS) ../po/%.po
	$(MKMAN) -po ../po/$*.po -i $< -o $@ $(CONFIGS)

notionflux.1: notionflux.in $(CONFIGS)
	$(MKMAN) -i $< -o $@ $(CONFIGS)

welcome%txt: welcome%head notion%1
	(cat welcome$*head; \
	$(NROFF) notion$*1 | $(FILTERCRAP)) > $@

_install:
	$(INSTALLDIR) $(DESTDIR)$(MANDIR)/man1
	$(INSTALL) -m $(DATA_MODE) notion.1 $(DESTDIR)$(MANDIR)/man1
	$(INSTALL) -m $(DATA_MODE) notionflux.1 $(DESTDIR)$(MANDIR)/man1
	for tr in $(TRANSLATIONS); do \
		$(INSTALLDIR) $(DESTDIR)$(MANDIR)/$$tr/man1 ; \
		$(INSTALL) -m $(DATA_MODE) notion.$$tr.1 $(DESTDIR)$(MANDIR)/$$tr/man1/notion.1 ; \
	done
	$(INSTALLDIR) $(DESTDIR)$(SHAREDIR)
	for i in $(WELCOME_TARGETS); do \
		$(INSTALL) -m $(DATA_MODE) $$i $(DESTDIR)$(SHAREDIR) ; \
	done

=== mod_dock/Makefile ===
##
## Notion dock module Makefile
##
##

# System specific configuration is in system.mk
TOPDIR=..
include $(TOPDIR)/build/system-inc.mk

######################################

INCLUDES += $(X11_INCLUDES) $(LIBTU_INCLUDES) $(LIBEXTL_INCLUDES) -I..
CFLAGS += $(XOPEN_SOURCE) $(C99_SOURCE)

SOURCES=dock.c
DOCS=LICENSE

MAKE_EXPORTS=mod_dock

MODULE=mod_dock

######################################

include $(TOPDIR)/build/rules.mk

######################################

_install: module_install

######################################

dock.o: exports.h

.PHONY: tags
tags:
	exuberant-ctags -R . $(TOPDIR)

=== mod_query/Makefile ===
##
## Query module Makefile
##

# System-specific configuration is in system.mk
TOPDIR=..
include $(TOPDIR)/build/system-inc.mk

######################################

INCLUDES += $(X11_INCLUDES) $(LIBTU_INCLUDES) $(LIBEXTL_INCLUDES) -I..
CFLAGS += $(XOPEN_SOURCE) $(C99_SOURCE)

SOURCES=complete.c edln.c input.c listing.c main.c wedln.c \
        wedln-wrappers.c wmessage.c query.c fwarn.c history.c

MAKE_EXPORTS=mod_query

MODULE=mod_query
MODULE_STUB=mod_query.lua
LUA_SOURCES=mod_query_chdir.lua

######################################

include $(TOPDIR)/build/rules.mk

######################################

main.o: exports.h

_install: module_install lc_install

=== mod_xrandr/Makefile ===
##
## Ion xrandr module Makefile
##
##

# System specific configuration is in system.mk
TOPDIR=..
include $(TOPDIR)/build/system-inc.mk

######################################

INCLUDES += $(LIBTU_INCLUDES) $(LIBEXTL_INCLUDES) $(X11_INCLUDES) -I$(TOPDIR) $(shell pkg-config --cflags-only-I xrandr)
CFLAGS += $(XOPEN_SOURCE) $(C99_SOURCE) $(shell $(PKG_CONFIG) --cflags-only-other xrandr)

SOURCES=mod_xrandr.c

MAKE_EXPORTS=mod_xrandr
LIBS = $(X11_LIBS) $(shell $(PKG_CONFIG) --libs xrandr)
MODULE=mod_xrandr
MODULE_STUB=mod_xrandr.lua
ETC=cfg_xrandr.lua


######################################

include $(TOPDIR)/build/rules.mk

######################################

_install: module_install
	$(INSTALLDIR) $(DESTDIR)$(ETCDIR)
	for i in $(ETC); do \
		$(INSTALL) -m $(DATA_MODE) $$i $(DESTDIR)$(ETCDIR); \
	done

######################################

.PHONY: tarball
tarball: $(SOURCES) $(ETC) $(DOCS) Makefile
	sh -c 'BASENAME=ion-devel-$(MODULE)-`date -r \`ls -t $+ | head -n 1\` +%Y%m%d`; \
		mkdir $$BASENAME; \
		cp $+ $$BASENAME; \
		tar -cvjf $$BASENAME.tar.bz2 $$BASENAME/*; \
		rm -Rf $$BASENAME'

.PHONY: test
test: $(SOURCES)
	for i in test_xrandr*.lua ; do echo 'Testing' $$i ; $(LUA) $$i ; done

######################################

.PHONY: tags
tags:
	exuberant-ctags -R . $(TOPDIR)

mod_xrandr.o: exports.h

=== notion/Makefile ===
##
## Notion Makefile
##

# System-specific configuration is in system.mk
TOPDIR=..
include $(TOPDIR)/build/system-inc.mk

# List of modules to possibly preload
include $(TOPDIR)/modulelist.mk

######################################

EXECUTABLE = notion

SOURCES = notion.c

INCLUDES += $(X11_INCLUDES)
INCLUDES += $(LIBMAINLOOP_INCLUDES) $(LIBTU_INCLUDES) $(LIBEXTL_INCLUDES)
INCLUDES += -I..

LIBS += $(X11_LIBS) -lSM -lICE
LIBS += $(WHOLEA) $(LIBMAINLOOP_LIBS) $(LIBEXTL_LIBS) $(LIBTU_LIBS) $(NO_WHOLEA)
LIBS += $(LUA_LIBS) $(DL_LIBS)
LIBS += -lm

MODULE_PATH = $(TOPDIR)

EXT_OBJS += ../ioncore/ioncore.a

DEFINES += -DETCDIR=\"$(ETCDIR)\" -DSHAREDIR=\"$(SHAREDIR)\" \
           -DEXTRABINDIR=\"$(EXTRABINDIR)\" -DMODULEDIR=\"$(MODULEDIR)\" \
	   -DLCDIR=\"$(LCDIR)\" -DLOCALEDIR=\"$(LOCALEDIR)\"

CFLAGS += $(XOPEN_SOURCE) $(C99_SOURCE)

######################################

include $(TOPDIR)/build/rules.mk

######################################


_install: executable_install

=== po/Makefile ===
##
## Notion po Makefile
##

# System-specific configuration is in system.mk
TOPDIR=..
include $(TOPDIR)/build/system-inc.mk

XGETTEXT = xgettext
#MSGFMT = msgfmt -c
MSGFMT = msgfmt
MSGMERGE = msgmerge
MSGCAT = msgcat
LXGETTEXT = lua-xgettext

TRANSLATIONS := fi cs fr de
MO_FILES := $(patsubst %,%.mo, $(TRANSLATIONS))
PO_FILES := $(patsubst %,%.po, $(TRANSLATIONS))

POTDIRS=../ioncore \
	../mod_tiling \
	../mod_query \
	../mod_menu \
	../mod_sm \
	../mod_sp \
	../mod_statusbar \
	../mod_mgmtmode \
	../de \
	../notion \
	../etc \
	$(LIBEXTL_DIR)

EXTRA_POTFILES_LUA=../build/mkman.lua

POTFILE=notion.pot

TARGETS = $(MO_FILES)

ifndef LOCALEDIR
LOCALEDIR := $(PREFIX)/share/locale
endif

######################################

include $(TOPDIR)/build/rules.mk

######################################

potfiles: potdirs_potfiles
	(for i in $(POTDIRS); do cat $$i/potfiles_c|sed "s:\w\+:$$i/&:"; done) > potfiles_c
	(for i in $(POTDIRS); do cat $$i/potfiles_lua|sed "s:\w\+:$$i/&:"; done; \
	 for i in $(EXTRA_POTFILES_LUA); do echo $$i; done) > potfiles_lua

potdirs_potfiles:
	for i in $(POTDIRS); do make -C $$i _potfiles; done

pot: $(POTFILE)

$(POTFILE)_c: potfiles
	$(XGETTEXT) -kTR -kDUMMY_TR -o $@ -f potfiles_c

$(POTFILE)_lua: potfiles
	$(LXGETTEXT) -k TR -k bdoc -k submenu -k menuentry -o $@ \
		`cat potfiles_lua`

$(POTFILE): $(POTFILE)_c $(POTFILE)_lua
	#
	# GNU gettext sucks bigtime, and refuses to work on POT
	# files without encoding set. Therefore we'll just have to
	# use plain old cat and hope that there aren't dupes.
	#
	#msgcat -o $@ $+
	#
	cat $+ > $@

%.mo: %.po
	$(MSGFMT) -o $@ $<

_install:
	for i in $(TRANSLATIONS); do \
		$(INSTALLDIR) $(DESTDIR)$(LOCALEDIR)/$$i/LC_MESSAGES ; \
		$(INSTALL) -m $(DATA_MODE) $$i.mo $(DESTDIR)$(LOCALEDIR)/$$i/LC_MESSAGES/notion.mo ; \
	done

update_fi: pot
	$(MSGMERGE) -U fi.po $(POTFILE)

update_cs: pot
	$(MSGMERGE) -U cs.po $(POTFILE)

update_fr: pot
	$(MSGMERGE) -U fr.po $(POTFILE)

update_de: pot
	$(MSGMERGE) -U de.po $(POTFILE)

=== test/Makefile ===
.PHONY: test

test:
	# For now integration tests don't work (lua-posix problems), skipping them
	#$(MAKE) -C integration test

=== utils/Makefile ===
##
## Notion utils/ Makefile
##

# System-specific configuration is in system.mk
TOPDIR=..
include $(TOPDIR)/build/system-inc.mk

######################################

SUBDIRS=ion-completefile ion-statusd
INSTALL_SUBDIRS=$(SUBDIRS)

SHELLSCRIPTS = ion-runinxterm ion-completeman notion-lock

TARGETS = ion-completeman

######################################

include $(TOPDIR)/build/rules.mk

######################################

_install:
	$(INSTALLDIR) $(DESTDIR)$(SHAREDIR)
	for i in $(SHELLSCRIPTS); do \
		$(INSTALL) -m $(BIN_MODE) $$i $(DESTDIR)$(SHAREDIR); \
	done

%: %.in
	sed 's#@SHAREDIR@#$(SHAREDIR)#g' $< | \
	sed 's#@VARDIR@#$(VARDIR)#g' > $@
	chmod $(BIN_MODE) $@

=== mod_notionflux/notionflux/Makefile ===
##
## Notionflux Makefile
##

# System-specific configuration is in system.mk
TOPDIR=../..
include $(TOPDIR)/build/system-inc.mk

######################################

CFLAGS += $(XOPEN_SOURCE)

INCLUDES += $(X11_INCLUDES) -I$(TOPDIR)

LIBS += $(X11_LIBS) 

EXTRA_EXECUTABLE = notionflux

SOURCES=notionflux.c

######################################

include $(TOPDIR)/build/rules.mk

######################################

_install: executable_install

=== debian/changelog ===
notion (3+2017050501-1) unstable; urgency=medium

  * New upstream release
    - Add focuslist menu for workspaces (thanks to @hedning)
    - Add sizepolicy support for menus (thanks to @hedning)
    - Fix statusd free memory (thanks to @jsbackus)
    - Improve error messages for invalid key combinations (thanks to @xmw and
      @knixeur)
    - configuration options for warp cursor placement (thanks to Campbell
      Barton)
    - include net_client_list in the default configuration
    - add Subtle(wm)-like window management to contrib scripts (@gwash)
    - add rofi menu support (thanks to @olejorgenb and @hedning)
    - various cleanups (thanks to Campbell Barton, Wojtek Aniszewski, @jsbackus,
      Joe Mason, @olejorgenb)

 -- Dima Kogan <dkogan@debian.org>  Fri, 22 Dec 2017 17:52:37 -0800

=== debian/control ===
Source: notion
Section: non-free/x11
Priority: optional
Maintainer: Arnout Engelen <arnouten@bzzt.net>
Uploaders: Dima Kogan <dkogan@debian.org>
Standards-Version: 4.1.2
Build-Depends: debhelper (>= 10), pkg-config, lua5.2, liblua5.2-dev, libx11-dev, libxext-dev, libsm-dev, libxinerama-dev, libxrandr-dev
XS-Autobuild: yes
Vcs-Browser: https://anonscm.debian.org/gitweb/?p=collab-maint/notion.git
Vcs-Git: https://anonscm.debian.org/git/collab-maint/notion.git
Homepage: http://notion.sourceforge.net/

Package: notion
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, xterm | x-terminal-emulator, x11-utils
Recommends: xfonts-75dpi | xfonts-75dpi-transcoded | xfonts-100dpi | xfonts-100dpi-transcoded, libxrandr2, libxinerama1
Suggests: menu (>= 2.1.9), docker
Provides: x-window-manager, notion-api-${source:Upstream-Version}
Replaces: particleman
Description: tiling tabbed window manager designed for keyboard users
 Notion divides the screen into tiles and places windows in these tiles
 by default.  Each tile has a set of tabs for the windows within it.
 It also allows windows to be made 'floating' and placed freely.  Notion
 can be controlled through the keyboard alone or together with a mouse.
 .
 Notion can be configured and extended using the Lua language.  It also
 supports extension modules written in C.

Package: notion-dev
Section: non-free/devel
Architecture: all
Depends: ${misc:Depends}, libx11-dev, libsm-dev, lua5.2, gcc (>> 3)
Description: Notion development files
 Notion divides the screen into tiles and places windows in these tiles
 by default.  Each tile has a set of tabs for the windows within it.
 It also allows windows to be made 'floating' and placed freely.  Notion
 can be controlled through the keyboard alone or together with a mouse.
 .
 This package contains the files necessary for building extension
 modules to the Notion window manager

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

# The upstream Makefiles do not look at CPPFLAGS. They should, and this should
# be unnecessary
override_dh_auto_build:
	CFLAGS="$(CFLAGS) $(CPPFLAGS)" dh_auto_build

override_dh_installman-arch:
	for langdir in debian/tmp/usr/share/man/*; do								\
		lang=`basename $$langdir`;									\
		test $$lang = "man1" || dh_installman --language $$lang debian/tmp/usr/share/man/$$lang/man1/*;	\
	done
	dh_installman --language C debian/tmp/usr/share/man/man1/* debian/install-notion-cfg.1

# I disable tests because these fail in multiple ways. The previous package
# didn't run the tests anyway
override_dh_auto_test:
	true

override_dh_installmenu-arch:
	dh_installmenu
	install -m644 debian/notion.menu-method.i18n \
		debian/notion/etc/menu-methods/notion-i18n

override_dh_install-indep:
	dh_install

	# install headers
	find . \( -name debian -o -name .pc -o -name config.h -o -name snprintf.h \) \
		-prune -o -name '*.h' -exec install -m644 -D {} \
		debian/notion-dev/usr/include/notion/{} \;

override_dh_fixperms-indep:
	dh_fixperms
	# this needs to be executable
	chmod a+x debian/notion-dev/usr/lib/notion/libextl/libextl-mkexports

override_dh_install-arch:
	dh_install
	# notionflux should go into /usr/bin. The upstream install should probably do this
	mv debian/notion/usr/lib/notion/notionflux debian/notion/usr/bin

=== debian/watch ===
version = 3
opts=uversionmangle=s/-/+/ https://github.com/raboof/notion/tags .*/notion/archive/(\d-\d+).tar.gz

## notion 4.0.1+dfsg

=== mod_dock/Makefile ===
--- 
+++ 
@@ -13,7 +13,7 @@
 CFLAGS += $(XOPEN_SOURCE) $(C99_SOURCE)
 
 SOURCES=dock.c
-DOCS=LICENSE
+DOCS=LICENSE README.dock
 
 MAKE_EXPORTS=mod_dock

=== mod_sm/Makefile ===
##
## Session management support module Makefile
##

# System-specific configuration is in system.mk
TOPDIR=..
include $(TOPDIR)/build/system-inc.mk

######################################

INCLUDES += $(X11_INCLUDES) $(LIBTU_INCLUDES) $(LIBEXTL_INCLUDES) -I..
CFLAGS += $(XOPEN_SOURCE) $(C99_SOURCE)
LIBS += $(X11_LIBS) -lSM -lICE

SOURCES=sm.c sm_matchwin.c sm_session.c

MAKE_EXPORTS=mod_sm

MODULE=mod_sm

######################################

include $(TOPDIR)/build/rules.mk

######################################

sm.o: exports.h

_install: module_install

## notion 4.0.2%2Bdfsg

=== ioncore/Makefile ===
##
## Notioncore Makefile
##

# System-specific configuration is in system.mk
TOPDIR=..
include $(TOPDIR)/build/system-inc.mk

######################################

INCLUDES += $(X11_INCLUDES) $(LIBTU_INCLUDES) $(LIBEXTL_INCLUDES) -I..

CFLAGS += $(XOPEN_SOURCE) $(C99_SOURCE)

SOURCES=binding.c conf-bindings.c cursor.c event.c exec.c focus.c         \
	strings.c key.c modules.c mwmhints.c pointer.c property.c         \
	screen.c sizehint.c window.c ioncore.c                   	  \
	xic.c selection.c clientwin.c colormap.c region.c eventh.c        \
	attach.c resize.c grab.c manage.c regbind.c    			  \
	rootwin.c tags.c names.c saveload.c frame.c                       \
	frame-pointer.c conf.c reginfo.c extlconv.c fullscreen.c mplex.c  \
	bindmaps.c gr.c infowin.c activity.c netwm.c frame-draw.c         \
	kbresize.c rectangle.c xwindow.c presize.c extlrx.c               \
        pholder.c mplexpholder.c llist.c basicpholder.c sizepolicy.c      \
        stacking.c group.c grouppholder.c group-cw.c navi.c		  \
        group-ws.c float-placement.c groupedpholder.c framedpholder.c	  \
        return.c detach.c screen-notify.c frame-tabs-recalc.c profiling.c \
        log.c tempdir.c

LUA_SOURCES=\
	ioncore_ext.lua ioncore_luaext.lua ioncore_bindings.lua \
	ioncore_winprops.lua ioncore_misc.lua ioncore_efbb.lua \
	ioncore_wd.lua ioncore_menudb.lua

ifeq ($(PRELOAD_MODULES),1)
CFLAGS += -DCF_PRELOAD_MODULES
endif

MAKE_EXPORTS=ioncore

TARGETS=ioncore.a

include $(TOPDIR)/libmainloop/rx.mk

######################################

include $(TOPDIR)/build/rules.mk

######################################

# without -finstrument-functions
profiling.o: profiling.c
	$(CC) $(CFLAGS:-finstrument-functions=) -c profiling.c -o profiling.o

ioncore.o: exports.h

ioncore.a: $(OBJS)
	$(AR) $(ARFLAGS) $@ $+
	$(RANLIB) $@

_install: lc_install

=== libextl/Makefile ===
##
## Extl Makefile
##

ifeq ($(MAKELEVEL),0)
TOPDIR=.
else
TOPDIR=..
endif

# System-specific configuration
include $(TOPDIR)/build/system-inc.mk

######################################

INCLUDES += $(LIBTU_INCLUDES) $(LUA_INCLUDES)

CFLAGS += $(XOPEN_SOURCE) $(C99_SOURCE)

SOURCES=readconfig.c luaextl.c misc.c

LIBS += $(LIBTU_LIBS) $(LUA_LIBS) $(DL_LIBS) -lm

HEADERS=readconfig.h extl.h luaextl.h private.h types.h

TARGETS=libextl.a libextl-mkexports

SUBDIRS = test

.PHONY : libextl-mkexports test

######################################

include $(TOPDIR)/build/rules.mk

######################################

ifdef LUA

libextl.a: $(OBJS)
	$(AR) $(ARFLAGS) $@ $+
	$(RANLIB) $@

libextl-mkexports: libextl-mkexports.in
	sed "1s:LUA50:$(LUA):" $< > $@

else

libextl.a: libextl-mkexports.in
	echo "Error: LUA interpreter and libraries not found (or inconsistent versions)"
	return -1

libextl-mkexports: libextl-mkexports.in
	echo "Error: LUA interpreter and libraries not found (or inconsistent versions)"
	return -1

endif

install:
	$(INSTALLDIR) $(DESTDIR)$(BINDIR)
	$(INSTALL) -m $(BIN_MODE) libextl-mkexports $(DESTDIR)$(BINDIR)
	$(INSTALLDIR) $(DESTDIR)$(LIBDIR)
	$(INSTALL) -m $(DATA_MODE) libextl.a $(DESTDIR)$(LIBDIR)
	$(INSTALLDIR) $(DESTDIR)$(INCDIR)
	for h in $(HEADERS); do \
		$(INSTALL) -m $(DATA_MODE) $$h $(DESTDIR)$(INCDIR); \
	done

test:
	$(MAKE) -C test test

=== mod_mgmtmode/Makefile ===
##
## Management mode module Makefile
##

# System-specific configuration is in system.mk
TOPDIR=..
include $(TOPDIR)/build/system-inc.mk

######################################

INCLUDES += $(X11_INCLUDES) $(LIBTU_INCLUDES) $(LIBEXTL_INCLUDES) -I..
CFLAGS += $(XOPEN_SOURCE) $(C99_SOURCE)

SOURCES=main.c mgmtmode.c

MAKE_EXPORTS=mod_mgmtmode

MODULE=mod_mgmtmode

######################################

include $(TOPDIR)/build/rules.mk

######################################

_install: module_install

=== mod_xkbevents/Makefile ===
##
## frame_xkb module Makefile
##

# System-specific configuration is in system.mk
TOPDIR=..
include $(TOPDIR)/build/system-inc.mk

######################################

INCLUDES += $(X11_INCLUDES) $(LIBTU_INCLUDES) $(LIBEXTL_INCLUDES) -I$(TOPDIR)
CFLAGS += $(XOPEN_SOURCE) $(C99_SOURCE) -Wall
LDFLAGS += $(X11_LIBS)

SOURCES=mod_xkbevents.c

MAKE_EXPORTS=mod_xkbevents

MODULE=mod_xkbevents


######################################

include $(TOPDIR)/build/rules.mk

######################################

mod_xkbevents.o: exports.h

_install: module_install

=== po/Makefile ===
--- 
+++ 
@@ -13,7 +13,7 @@
 MSGCAT = msgcat
 LXGETTEXT = lua-xgettext
 
-TRANSLATIONS := fi cs fr de
+TRANSLATIONS := fi cs
 MO_FILES := $(patsubst %,%.mo, $(TRANSLATIONS))
 PO_FILES := $(patsubst %,%.po, $(TRANSLATIONS))
 
@@ -88,9 +88,3 @@
 update_cs: pot
 	$(MSGMERGE) -U cs.po $(POTFILE)
 
-update_fr: pot
-	$(MSGMERGE) -U fr.po $(POTFILE)
-
-update_de: pot
-	$(MSGMERGE) -U de.po $(POTFILE)
-

=== mod_statusbar/ion-statusd/Makefile ===
##
## Notion ion-statusd Makefile
##

# System-specific configuration is in system.mk
TOPDIR=../..
include $(TOPDIR)/build/system-inc.mk

######################################

INCLUDES += $(LIBMAINLOOP_INCLUDES) $(LIBEXTL_INCLUDES) $(LIBTU_INCLUDES)
LIBS += $(LIBMAINLOOP_LIBS) $(LIBEXTL_LIBS) $(LIBTU_LIBS) $(LUA_LIBS) $(DL_LIBS) -lm
CFLAGS += $(XOPEN_SOURCE) $(C99_SOURCE)

DEFINES += -DETCDIR=\"$(ETCDIR)\" -DSHAREDIR=\"$(SHAREDIR)\" \
           -DEXTRABINDIR=\"$(EXTRABINDIR)\" -DMODULEDIR=\"$(MODULEDIR)\" \
	   -DLCDIR=\"$(LCDIR)\" -DLOCALEDIR=\"$(LOCALEDIR)\" \
	   -DCF_ION_EXECUTABLE=\"notion\"

SOURCES = ion-statusd.c exec.c extlrx.c

TARGETS = ion-statusd

LUA_SOURCES = statusd_date.lua statusd_mail.lua statusd_load.lua

MAKE_EXPORTS = statusd

include $(TOPDIR)/libmainloop/rx.mk

######################################

include $(TOPDIR)/build/rules.mk

######################################

ion-statusd: $(OBJS) $(EXT_OBJS)
	$(CC) $(LINKOPTS) $(OBJS) $(EXT_OBJS) $(LDFLAGS) -o $@

_install: lc_install
	$(INSTALLDIR) $(DESTDIR)$(EXTRABINDIR)
	$(INSTALL) -s -m $(BIN_MODE) ion-statusd $(DESTDIR)$(EXTRABINDIR)

=== debian/changelog ===
notion (4.0.2+dfsg-7build1) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 02:40:53 +0000

notion (4.0.2+dfsg-7) unstable; urgency=medium

  * Added forgotten #include in patch. (Closes: #1066322)
  * /etc/X11/notion/cfg_debian_ext.lua is installed in the package
    (Closes: #679764)
  * added "clean" target (Closes: #1047621)

 -- Dima Kogan <dkogan@debian.org>  Mon, 18 Mar 2024 18:17:46 -0700

notion (4.0.2+dfsg-6) unstable; urgency=medium

  * Fixed debian/watch

 -- Dima Kogan <dkogan@debian.org>  Fri, 12 Nov 2021 12:11:39 -0800

notion (4.0.2+dfsg-5) unstable; urgency=medium

  * dh_missing now flags warnings not errors (Closes: #987507)

 -- Dima Kogan <dkogan@debian.org>  Sun, 25 Apr 2021 23:41:14 -0700

notion (4.0.2+dfsg-4) unstable; urgency=medium

  * Fix FTCBFS: Use the host architecture pkg-config. Thanks to Helmut
    Grohne! (Closes: #982291)

 -- Dima Kogan <dkogan@debian.org>  Sat, 27 Feb 2021 21:52:44 -0800

notion (4.0.2+dfsg-3) unstable; urgency=medium

  * Building with xft support

 -- Dima Kogan <dkogan@debian.org>  Sun, 21 Feb 2021 10:51:28 -0800

notion (4.0.2+dfsg-2) unstable; urgency=medium

  * notion and notion-i18n menu entries are both generated.
    (Closes: #981377)

 -- Dima Kogan <dkogan@debian.org>  Sat, 30 Jan 2021 18:27:28 -0800

notion (4.0.2+dfsg-1) unstable; urgency=medium

  * New upstream release
  * Updated the homepage in debian/control (Closes: #933226)
  * Updated /etc/default/notion with default ALTMETA (Closes: #978980)
  * Dima Kogan is the maintainer

 -- Dima Kogan <dkogan@debian.org>  Wed, 13 Jan 2021 23:01:07 -0800

notion (4.0.1+dfsg-2) unstable; urgency=medium

  * Uploading to unstable

 -- Dima Kogan <dkogan@debian.org>  Tue, 29 Dec 2020 13:17:52 -0800

notion (4.0.1+dfsg-1) experimental; urgency=medium

  * Upstream update
    - Release notes at https://github.com/raboof/notion/releases/tag/4.0.1
    - Migration notes at https://notionwm.net/migration.html
    - Notably, Notion is now LGPL again, so can be moved back
      from non-free into the general distribution
  * Bump debhelper from old 10 to 12.
  * Set debhelper-compat version in Build-Depends.
  * Set upstream metadata fields: Bug-Database, Bug-Submit.
  * Fix day-of-week for changelog entry 20050322-2.
  * Excluding everything in contrib/ without an explicit license statement

 -- Dima Kogan <dkogan@debian.org>  Mon, 16 Nov 2020 00:38:24 -0800

notion (3+2019092501-1) experimental; urgency=medium

  * Upstream update
    - Depending on lua5.3, not lua5.2

 -- Dima Kogan <dkogan@debian.org>  Sun, 29 Sep 2019 20:27:06 -0700

## notion 4.0.2+dfsg

=== Makefile ===
##
## Notion Makefile
##

export NOTION_RELEASE = $(shell ./version.sh)

# Include system-specific configuration: auto-generated and optionally local
include build/system-inc.mk

# List of modules
include modulelist.mk

######################################

INSTALL_SUBDIRS=\
	$(MODULE_LIST) \
	ioncore notion etc utils man po contrib/scripts

SUBDIRS = $(LIBS_SUBDIRS) $(INSTALL_SUBDIRS)

DOCS = README.md LICENSE AUTHORS CONTRIBUTING.md

TO_REALCLEAN = build/ac/system-ac.mk

POTFILE=po/notion.pot

######################################

include build/rules.mk

######################################

_install:
	$(INSTALLDIR) $(DESTDIR)$(DOCDIR)
	for i in $(DOCS); do \
		$(INSTALL) -m $(DATA_MODE) $$i $(DESTDIR)$(DOCDIR); \
	done

RELEASE_TARGETS := $(addsuffix -release,major minor patch)
$(RELEASE_TARGETS):
	@./nextversion.sh $(@) >/dev/null 2>/dev/null
	$(eval RELEASE_VERSION=$(shell ./nextversion.sh $(@)))
	git tag -s -m "Release $(RELEASE_VERSION)" $(RELEASE_VERSION)
	@echo 'Use "git push --tags" to push the newly tagged release.'

.PHONY: test $(RELEASE_TARGETS)

test:
	$(MAKE) -C mod_xrandr test
	$(MAKE) -C mod_xinerama test
	$(MAKE) -C libtu test
	$(MAKE) -C libextl test
	$(MAKE) -C test

=== de/Makefile ===
##
## Default drawing engine module Makefile
##

# System-specific configuration is in system.mk
TOPDIR=..
include $(TOPDIR)/build/system-inc.mk

######################################

INCLUDES += $(X11_INCLUDES) $(LIBTU_INCLUDES) $(LIBEXTL_INCLUDES) -I..
CFLAGS += $(XOPEN_SOURCE) $(C99_SOURCE)

SOURCES=init.c draw.c font.c colour.c brush.c fontset.c style.c

MODULE=de

MAKE_EXPORTS=de

######################################

include $(TOPDIR)/build/rules.mk

######################################

init.o: exports.h

_install: module_install

=== libmainloop/Makefile ===
##
## Libmainloop Makefile
##

# System-specific configuration is in system.mk
TOPDIR=..
include $(TOPDIR)/build/system-inc.mk

######################################

INCLUDES += $(LIBTU_INCLUDES) $(LIBEXTL_INCLUDES) -I..

CFLAGS += $(XOPEN_SOURCE) $(C99_SOURCE)

SOURCES = select.c defer.c signal.c hooks.c exec.c

#MAKE_EXPORTS=mainloop

TARGETS = libmainloop.a

######################################

include $(TOPDIR)/build/rules.mk

######################################

libmainloop.a: $(OBJS)
	$(AR) $(ARFLAGS) $@ $+
	$(RANLIB) $@

_install:

=== libtu/Makefile ===
##
## Tu Makefile
##

# System-specific configuration is in system.mk
ifeq ($(MAKELEVEL),0)
TOPDIR=.
else
TOPDIR=..
endif

# System-specific configuration
include $(TOPDIR)/build/system-inc.mk

######################################

#INCLUDES += $(LIBTU_INCLUDES) $(LUA_INCLUDES)

CFLAGS += $(C89_SOURCE) $(POSIX_SOURCE) $(WARN)

SOURCES=iterable.c  map.c  misc.c  obj.c  objlist.c  optparser.c  output.c  parser.c  prefix.c  ptrlist.c  rb.c  setparam.c  stringstore.c  tokenizer.c  util.c errorlog.c

HEADERS=debug.h  errorlog.h  locale.h  minmax.h  obj.h      objp.h       output.h  pointer.h  private.h  rb.h        stringstore.h  types.h dlist.h  iterable.h  map.h     misc.h    objlist.h  optparser.h  parser.h  prefix.h   ptrlist.h  setparam.h  tokenizer.h    util.h

TARGETS=libtu.a

SUBDIRS = test

######################################

include $(TOPDIR)/build/rules.mk

######################################

.PHONY: test

libtu.a: $(OBJS)
	$(AR) $(ARFLAGS) $@ $+
	$(RANLIB) $@

install:
	$(INSTALLDIR) $(DESTDIR)$(LIBDIR)
	$(INSTALL) -m $(DATA_MODE) libtu.a $(DESTDIR)$(LIBDIR)
	$(INSTALLDIR) $(DESTDIR)$(INCDIR)/libtu
	for h in $(HEADERS); do \
		$(INSTALL) -m $(DATA_MODE) $$h $(DESTDIR)$(INCDIR)/libtu; \
	done

test:
	$(MAKE) -C test test

=== man/Makefile ===
##
## Notion manual page Makefile
##

# System-specific configuration is in system.mk
TOPDIR=..
include $(TOPDIR)/build/system-inc.mk

######################################

SHELL=bash -o pipefail

TARGETS=notion.1 notionflux.1 welcome.txt

MKMAN=$(LUA) ../build/mkman.lua
NROFF=nroff -man -Tlatin1
#FILTERCRAP=perl -p -i -e 's/.\10//g'
FILTERCRAP=$(LUA) -e 'io.write((string.gsub(io.read("*a"), ".\8", "")))'
LUA_REFVERSION:=$(shell $(LUA) -e 'print(_VERSION:match("[\x25d.]+"))')

CONFIGS=../etc/cfg_bindings.lua \
	../etc/cfg_tiling.lua \
	../etc/cfg_query.lua \
	../etc/cfg_menu.lua

######################################

include $(TOPDIR)/build/rules.mk

######################################

notion.1: notion.in $(CONFIGS)
	$(MKMAN) -i $< -o $@ -D ETCDIR $(ETCDIR) -D DOCDIR $(DOCDIR) $(CONFIGS)

notion.%.1: notion.%.in $(CONFIGS) ../po/%.po
	$(MKMAN) -po ../po/$*.po -i $< -o $@ -D ETCDIR $(ETCDIR) -D DOCDIR $(DOCDIR) $(CONFIGS)

notionflux.1: notionflux.in $(CONFIGS)
	$(MKMAN) -i $< -o $@ -D DOCDIR $(DOCDIR) -D LUA_REFVERSION $(LUA_REFVERSION) $(CONFIGS)

welcome%txt: welcome%head notion%1
	(cat welcome$*head; \
	$(NROFF) notion$*1 | $(FILTERCRAP)) > $@

_install:
	$(INSTALLDIR) $(DESTDIR)$(MANDIR)/man1
	$(INSTALL) -m $(DATA_MODE) notion.1 $(DESTDIR)$(MANDIR)/man1
	$(INSTALL) -m $(DATA_MODE) notionflux.1 $(DESTDIR)$(MANDIR)/man1
	$(INSTALLDIR) $(DESTDIR)$(SHAREDIR)
	for i in $(TARGETS); do \
		$(INSTALL) -m $(DATA_MODE) $$i $(DESTDIR)$(SHAREDIR) ; \
	done

clean:
	$(RM) -f $(TARGETS)

.PHONY: clean

=== mod_tiling/Makefile ===
##
## Notion workspace module Makefile
##

# System-specific configuration is in system.mk
TOPDIR=..
include $(TOPDIR)/build/system-inc.mk

######################################

INCLUDES += $(X11_INCLUDES) $(LIBTU_INCLUDES) $(LIBEXTL_INCLUDES) -I..
CFLAGS += $(XOPEN_SOURCE) $(C99_SOURCE)

SOURCES=main.c tiling.c placement.c split.c split-stdisp.c \
	splitfloat.c panehandle.c ops.c

MAKE_EXPORTS=mod_tiling

MODULE=mod_tiling
MODULE_STUB=mod_tiling.lua

######################################

include $(TOPDIR)/build/rules.mk

######################################

main.o: exports.h

_install: module_install

=== mod_xinerama/Makefile ===
##
## Ion xinerama module Makefile
##
##

# System specific configuration is in system.mk
TOPDIR=..
include $(TOPDIR)/build/system-inc.mk

######################################

XINERAMA_CFLAGS_ONLYI     := $(shell $(PKG_CONFIG) --cflags-only-I xinerama)
XINERAMA_CFLAGS_ONLYOTHER := $(shell $(PKG_CONFIG) --cflags-only-other xinerama)
XINERAMA_LDLIBS           := $(shell $(PKG_CONFIG) --libs xinerama)

INCLUDES += $(LIBTU_INCLUDES) $(LIBEXTL_INCLUDES) $(X11_INCLUDES) -I$(TOPDIR) $(XINERAMA_CFLAGS_ONLYI)
CFLAGS += $(XOPEN_SOURCE) $(C99_SOURCE) $(XINERAMA_CFLAGS_ONLYOTHER)
DOCS=LICENSE README

SOURCES=mod_xinerama.c

MAKE_EXPORTS=mod_xinerama
LIBS = $(X11_LIBS) $(XINERAMA_LDLIBS)
MODULE=mod_xinerama
MODULE_STUB=mod_xinerama.lua

######################################

include $(TOPDIR)/build/rules.mk

######################################

_install: module_install
	$(INSTALLDIR) $(DESTDIR)$(ETCDIR)
	for i in $(ETC); do \
		$(INSTALL) -m $(DATA_MODE) $$i $(DESTDIR)$(ETCDIR); \
	done

######################################

.PHONY: tarball
tarball: $(SOURCES) $(ETC) $(DOCS) $(MODULE_STUB) Makefile
	sh -c 'BASENAME=ion-devel-$(MODULE)-`date -r \`ls -t $+ | head -n 1\` +%Y%m%d`; \
		mkdir $$BASENAME; \
		cp $+ $$BASENAME; \
		tar -cvjf $$BASENAME.tar.bz2 $$BASENAME/*; \
		rm -Rf $$BASENAME'

.PHONY: test
test: $(SOURCES)
	$(LUA) test_xinerama.lua

######################################

.PHONY: tags
tags:
	exuberant-ctags -R . $(TOPDIR)

mod_xinerama.o: exports.h

################ ls_xinerama utility ###############

ls_xinerama: ls_xinerama.c
	$(CC) $(CFLAGS) ls_xinerama.c -o ls_xinerama $(LDFLAGS) $(LIBS)

=== notion/Makefile ===
--- 
+++ 
@@ -11,20 +11,30 @@
 
 ######################################
 
-EXECUTABLE = notion
+SOURCES=notion.c
 
-SOURCES = notion.c
+TARGETS=notion
 
 INCLUDES += $(X11_INCLUDES)
 INCLUDES += $(LIBMAINLOOP_INCLUDES) $(LIBTU_INCLUDES) $(LIBEXTL_INCLUDES)
 INCLUDES += -I..
 
-LIBS += $(X11_LIBS) -lSM -lICE
+LIBS += $(X11_LIBS)
 LIBS += $(WHOLEA) $(LIBMAINLOOP_LIBS) $(LIBEXTL_LIBS) $(LIBTU_LIBS) $(NO_WHOLEA)
 LIBS += $(LUA_LIBS) $(DL_LIBS)
 LIBS += -lm
 
-MODULE_PATH = $(TOPDIR)
+ifeq ($(PRELOAD_MODULES),1)
+EXT_OBJS += $(foreach mod, $(MODULE_LIST), ../$(mod)/$(mod).a)
+DEPEND_DEPENDS += preload.c
+SOURCES += preload.c
+TO_CLEAN += preload.c
+LIBS += -lSM -lICE
+else
+LINKOPTS = $(EXPORT_DYNAMIC)
+WHOLEA = -Wl,-whole-archive
+NO_WHOLEA = -Wl,-no-whole-archive
+endif
 
 EXT_OBJS += ../ioncore/ioncore.a
 
@@ -40,6 +50,12 @@
 
 ######################################
 
+notion: $(OBJS) $(EXT_OBJS)
+	$(CC) $(LINKOPTS) $(OBJS) $(WHOLEA) $(EXT_OBJS) $(NO_WHOLEA) $(LDFLAGS) -o $@
 
-_install: executable_install
+preload.c:
+	$(LUA) ../build/mkpreload.lua $(MODULE_LIST) > preload.c
 
+_install:
+	$(INSTALLDIR) $(DESTDIR)$(BINDIR)
+	$(INSTALL) -m $(BIN_MODE) notion $(DESTDIR)$(BINDIR)

=== utils/Makefile ===
--- 
+++ 
@@ -8,7 +8,7 @@
 
 ######################################
 
-SUBDIRS=ion-completefile ion-statusd
+SUBDIRS=ion-completefile
 INSTALL_SUBDIRS=$(SUBDIRS)
 
 SHELLSCRIPTS = ion-runinxterm ion-completeman notion-lock

=== libextl/test/Makefile ===
# System-specific configuration is in system.mk
TOPDIR=../..
include $(TOPDIR)/build/system-inc.mk

######################################

# SOURCES=../readconfig.c ../misc.c

#LIBS += $(LUA_LIBS) $(DL_LIBS) -lm
INCLUDES += -I.. $(LIBTU_INCLUDES) $(LUA_INCLUDES)
CFLAGS += $(XOPEN_SOURCE) $(C99_SOURCE)

SOURCES=../readconfig.c ../misc.c

LIBS += $(LIBTU_LIBS) $(LUA_LIBS) $(DL_LIBS) -lm

HEADERS=readconfig.h extl.h luaextl.h private.h types.h


######################################

include $(TOPDIR)/build/rules.mk

######################################

test: $(SOURCES)
	$(CC) $(CFLAGS) -o extltest $(SOURCES) extltest.c $(INCLUDES) $(LIBS)
	./extltest
	# $(RM) extltest

=== libtu/test/Makefile ===
# System-specific configuration is in system.mk
TOPDIR=../..
include $(TOPDIR)/build/system-inc.mk

######################################

SOURCES=../misc.c ../tokenizer.c ../util.c ../output.c

LIBS += $(LUA_LIBS) $(DL_LIBS) -lm
INCLUDES += $(LIBTU_INCLUDES)
CFLAGS += $(XOPEN_SOURCE) $(C99_SOURCE)

######################################

include $(TOPDIR)/build/rules.mk

######################################

test: $(SOURCES)
	$(CC) $(CFLAGS) -o tutest $(SOURCES) tutest.c $(LIBS)
	./tutest
	$(RM) ./tutest

=== mod_notionflux/notionflux/Makefile ===
##
## Notionflux Makefile
##

# System-specific configuration is in system.mk
TOPDIR=../..
USE_READLINE := 1
include $(TOPDIR)/build/system-inc.mk

######################################

SOURCES=notionflux.c

TARGETS=notionflux

CFLAGS += $(C99_SOURCE)

INCLUDES += $(X11_INCLUDES) $(LUA_INCLUDES) $(READLINE_INCLUDES) -I$(TOPDIR)

LIBS += $(X11_LIBS) $(LUA_LIBS) $(READLINE_LIBS)

EXTRA_EXECUTABLE = notionflux

######################################

include $(TOPDIR)/build/rules.mk

######################################

notionflux: $(OBJS) $(EXT_OBJS)
	$(CC) $(LINKOPTS) $(OBJS) $(WHOLEA) $(EXT_OBJS) $(NO_WHOLEA) $(LDFLAGS) -o $@

_install: notionflux
	$(INSTALLDIR) $(DESTDIR)$(BINDIR)
	$(INSTALL) -m $(BIN_MODE) notionflux $(DESTDIR)$(BINDIR)

=== debian/control ===
Source: notion
Section: x11
Priority: optional
Maintainer: Dima Kogan <dkogan@debian.org>
Standards-Version: 4.1.2
Build-Depends: debhelper-compat (= 13), pkg-config, lua5.3, liblua5.3-dev, libx11-dev, libxext-dev, libsm-dev, libxinerama-dev, libxrandr-dev, libxft-dev
XS-Autobuild: yes
Vcs-Browser: https://salsa.debian.org/debian/notion
Vcs-Git: https://salsa.debian.org/debian/notion.git
Homepage: https://www.notionwm.net

Package: notion
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, xterm | x-terminal-emulator, x11-utils, menu (>= 2.1.9)
Recommends: xfonts-75dpi | xfonts-75dpi-transcoded | xfonts-100dpi | xfonts-100dpi-transcoded, libxrandr2, libxinerama1
Suggests: wmdocker
Provides: x-window-manager, notion-api-${source:Upstream-Version}
Replaces: particleman
Description: tiling tabbed window manager designed for keyboard users
 Notion divides the screen into tiles and places windows in these tiles
 by default.  Each tile has a set of tabs for the windows within it.
 It also allows windows to be made 'floating' and placed freely.  Notion
 can be controlled through the keyboard alone or together with a mouse.
 .
 Notion can be configured and extended using the Lua language.  It also
 supports extension modules written in C.

Package: notion-dev
Section: devel
Architecture: all
Depends: ${misc:Depends}, libx11-dev, libsm-dev, lua5.3, gcc (>> 3)
Description: Notion development files
 Notion divides the screen into tiles and places windows in these tiles
 by default.  Each tile has a set of tabs for the windows within it.
 It also allows windows to be made 'floating' and placed freely.  Notion
 can be controlled through the keyboard alone or together with a mouse.
 .
 This package contains the files necessary for building extension
 modules to the Notion window manager

=== debian/watch ===
version=4
opts="repacksuffix=+dfsg,dversionmangle=s/\+dfsg//g,repack,filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%notion-$1.tar.gz%" https://github.com/raboof/notion/tags .*/notion/archive/(\d+\.\d+\.\d+).tar.gz

## notion 4.0.3+dfsg

=== etc/Makefile ===
##
## Notion etc Makefile
##

# System-specific configuration is in system.mk
TOPDIR=..
include $(TOPDIR)/build/system-inc.mk

######################################

ETC =	cfg_notion.lua cfg_notioncore.lua cfg_kludges.lua cfg_defaults.lua \
	cfg_tiling.lua cfg_query.lua cfg_menu.lua cfg_bindings.lua \
	cfg_notion3_keybindings.lua cfg_notion3_tiling.lua \
	cfg_statusbar.lua cfg_dock.lua cfg_layouts.lua \
	look_brownsteel.lua look_clean.lua look_dusky.lua \
	look_greyviolet.lua look_ios.lua look_cleanviolet.lua \
	look_simpleblue.lua look_cleanios.lua \
	look.lua \
	look_newviolet.lua look_newviolet_hidpi.lua \
	look_greenlight.lua look_paper.lua \
	lookcommon_clean.lua lookcommon_clean_stdisp.lua \
	lookcommon_clean_tab.lua lookcommon_clean_frame.lua \
	lookcommon_emboss.lua lookcommon_emboss_stdisp.lua \
	lookcommon_emboss_tab.lua lookcommon_emboss_frame.lua

######################################

include $(TOPDIR)/build/rules.mk

######################################

_install: etc_install

=== ioncore/Makefile ===
--- 
+++ 
@@ -50,12 +50,11 @@
 
 # without -finstrument-functions
 profiling.o: profiling.c
-	$(CC) $(CFLAGS:-finstrument-functions=) -c profiling.c -o profiling.o
+	$(CC) $(CPPFLAGS) $(CFLAGS:-finstrument-functions=) -c $< -o $@
 
 ioncore.o: exports.h
 
 ioncore.a: $(OBJS)
 	$(AR) $(ARFLAGS) $@ $+
-	$(RANLIB) $@
 
 _install: lc_install

=== libextl/Makefile ===
--- 
+++ 
@@ -39,7 +39,6 @@
 
 libextl.a: $(OBJS)
 	$(AR) $(ARFLAGS) $@ $+
-	$(RANLIB) $@
 
 libextl-mkexports: libextl-mkexports.in
 	sed "1s:LUA50:$(LUA):" $< > $@

=== libmainloop/Makefile ===
--- 
+++ 
@@ -26,6 +26,5 @@
 
 libmainloop.a: $(OBJS)
 	$(AR) $(ARFLAGS) $@ $+
-	$(RANLIB) $@
 
 _install:

=== mod_notionflux/Makefile ===
##
## mod_notionflux Makefile
##

# System-specific configuration is in system.mk
TOPDIR=..
include $(TOPDIR)/build/system-inc.mk

######################################

INSTALL_SUBDIRS = notionflux
SUBDIRS = $(INSTALL_SUBDIRS)

######################################

INCLUDES += $(X11_INCLUDES) -I$(TOPDIR)
CFLAGS += $(XOPEN_SOURCE) $(C99_SOURCE)

SOURCES=mod_notionflux.c
MAKE_EXPORTS=mod_notionflux

MODULE_STUB=mod_notionflux.lua
MODULE=mod_notionflux

######################################

include $(TOPDIR)/build/rules.mk

######################################

_install: module_install

######################################

mod_notionflux.o: exports.h

=== mod_statusbar/Makefile ===
##
## Notion mod_statusbar Makefile
##

# System-specific configuration is in system.mk
TOPDIR=..
include $(TOPDIR)/build/system-inc.mk

######################################

INCLUDES += $(X11_INCLUDES) $(LIBTU_INCLUDES) $(LIBEXTL_INCLUDES) -I..
CFLAGS += $(XOPEN_SOURCE) $(C99_SOURCE)

SOURCES = main.c statusbar.c draw.c

SUBDIRS = ion-statusd
INSTALL_SUBDIRS = $(SUBDIRS)

MAKE_EXPORTS = mod_statusbar

MODULE = mod_statusbar
MODULE_STUB = mod_statusbar.lua

######################################

include $(TOPDIR)/build/rules.mk

######################################

main.o: exports.h

_install: module_install

=== mod_xinerama/Makefile ===
--- 
+++ 
@@ -61,4 +61,4 @@
 ################ ls_xinerama utility ###############
 
 ls_xinerama: ls_xinerama.c
-	$(CC) $(CFLAGS) ls_xinerama.c -o ls_xinerama $(LDFLAGS) $(LIBS)
+	$(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) ls_xinerama.c -o $@ $(LIBS)

=== notion/Makefile ===
--- 
+++ 
@@ -11,6 +11,9 @@
 
 ######################################
 
+LD_START_GROUP := -Wl,--start-group
+LD_END_GROUP := -Wl,--end-group
+
 SOURCES=notion.c
 
 TARGETS=notion
@@ -19,10 +22,8 @@
 INCLUDES += $(LIBMAINLOOP_INCLUDES) $(LIBTU_INCLUDES) $(LIBEXTL_INCLUDES)
 INCLUDES += -I..
 
-LIBS += $(X11_LIBS)
-LIBS += $(WHOLEA) $(LIBMAINLOOP_LIBS) $(LIBEXTL_LIBS) $(LIBTU_LIBS) $(NO_WHOLEA)
-LIBS += $(LUA_LIBS) $(DL_LIBS)
-LIBS += -lm
+LIBS += $(LD_START_GROUP) $(LIBMAINLOOP_LIBS) $(LIBEXTL_LIBS) $(LIBTU_LIBS) $(LD_END_GROUP)
+LIBS += $(X11_LIBS) $(LUA_LIBS) $(DL_LIBS) -lm
 
 ifeq ($(PRELOAD_MODULES),1)
 EXT_OBJS += $(foreach mod, $(MODULE_LIST), ../$(mod)/$(mod).a)
@@ -40,7 +41,7 @@
 
 DEFINES += -DETCDIR=\"$(ETCDIR)\" -DSHAREDIR=\"$(SHAREDIR)\" \
            -DEXTRABINDIR=\"$(EXTRABINDIR)\" -DMODULEDIR=\"$(MODULEDIR)\" \
-	   -DLCDIR=\"$(LCDIR)\" -DLOCALEDIR=\"$(LOCALEDIR)\"
+           -DLCDIR=\"$(LCDIR)\" -DLOCALEDIR=\"$(LOCALEDIR)\"
 
 CFLAGS += $(XOPEN_SOURCE) $(C99_SOURCE)
 
@@ -51,11 +52,11 @@
 ######################################
 
 notion: $(OBJS) $(EXT_OBJS)
-	$(CC) $(LINKOPTS) $(OBJS) $(WHOLEA) $(EXT_OBJS) $(NO_WHOLEA) $(LDFLAGS) -o $@
+	$(CC) $(CFLAGS) $(LDFLAGS) $(LINKOPTS) $(OBJS) $(WHOLEA) $(EXT_OBJS) $(NO_WHOLEA) -o $@ $(LIBS)
 
 preload.c:
 	$(LUA) ../build/mkpreload.lua $(MODULE_LIST) > preload.c
 
 _install:
 	$(INSTALLDIR) $(DESTDIR)$(BINDIR)
-	$(INSTALL) -m $(BIN_MODE) notion $(DESTDIR)$(BINDIR)
+	$(INSTALL) $(INSTALL_STRIP) -m $(BIN_MODE) notion $(DESTDIR)$(BINDIR)

=== po/Makefile ===
--- 
+++ 
@@ -24,7 +24,6 @@
 	../mod_sm \
 	../mod_sp \
 	../mod_statusbar \
-	../mod_mgmtmode \
 	../de \
 	../notion \
 	../etc \

=== libtu/test/Makefile ===
--- 
+++ 
@@ -6,7 +6,7 @@
 
 SOURCES=../misc.c ../tokenizer.c ../util.c ../output.c
 
-LIBS += $(LUA_LIBS) $(DL_LIBS) -lm
+LIBS += $(LUA_LIBS) $(DL_LIBS) $(LIBTU_LIBS) -lm
 INCLUDES += $(LIBTU_INCLUDES)
 CFLAGS += $(XOPEN_SOURCE) $(C99_SOURCE)
 
@@ -17,6 +17,6 @@
 ######################################
 
 test: $(SOURCES)
-	$(CC) $(CFLAGS) -o tutest $(SOURCES) tutest.c $(LIBS)
+	$(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) $(INCLUDES) -o tutest $(SOURCES) tutest.c $(LIBS)
 	./tutest
 	$(RM) ./tutest

=== mod_statusbar/ion-statusd/Makefile ===
--- 
+++ 
@@ -14,8 +14,8 @@
 
 DEFINES += -DETCDIR=\"$(ETCDIR)\" -DSHAREDIR=\"$(SHAREDIR)\" \
            -DEXTRABINDIR=\"$(EXTRABINDIR)\" -DMODULEDIR=\"$(MODULEDIR)\" \
-	   -DLCDIR=\"$(LCDIR)\" -DLOCALEDIR=\"$(LOCALEDIR)\" \
-	   -DCF_ION_EXECUTABLE=\"notion\"
+           -DLCDIR=\"$(LCDIR)\" -DLOCALEDIR=\"$(LOCALEDIR)\" \
+           -DCF_ION_EXECUTABLE=\"notion\"
 
 SOURCES = ion-statusd.c exec.c extlrx.c
 
@@ -34,8 +34,8 @@
 ######################################
 
 ion-statusd: $(OBJS) $(EXT_OBJS)
-	$(CC) $(LINKOPTS) $(OBJS) $(EXT_OBJS) $(LDFLAGS) -o $@
+	$(CC) $(CFLAGS) $(LDFLAGS) $(LINKOPTS) $(OBJS) $(EXT_OBJS) -o $@ $(LIBS)
 
 _install: lc_install
 	$(INSTALLDIR) $(DESTDIR)$(EXTRABINDIR)
-	$(INSTALL) -s -m $(BIN_MODE) ion-statusd $(DESTDIR)$(EXTRABINDIR)
+	$(INSTALL) $(INSTALL_STRIP) -m $(BIN_MODE) ion-statusd $(DESTDIR)$(EXTRABINDIR)

=== test/integration/Makefile ===
.PHONY: test

CFLAGS ?= -O2 -Wall

libXinerama.so.1.0: Xinerama.c
	$(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) Xinerama.c -fPIC -o $@ -shared -Wl,-soname -Wl,$@

test: libXinerama.so.1.0
	LD_PRELOAD=`pwd`/libXinerama.so.1.0 $(LUA) ./runtests.lua

=== debian/changelog ===
notion (4.0.3+dfsg-2) unstable; urgency=medium

  * Build with the c17 standard (Closes: #1097476

 -- Dima Kogan <dkogan@debian.org>  Wed, 24 Sep 2025 23:20:06 -0700

notion (4.0.3+dfsg-1) unstable; urgency=medium

  * New upstream release (Closes: #1075318)

 -- Dima Kogan <dkogan@debian.org>  Fri, 03 Jan 2025 10:40:10 -0800

=== debian/control ===
--- 
+++ 
@@ -11,7 +11,7 @@
 
 Package: notion
 Architecture: any
-Depends: ${misc:Depends}, ${shlibs:Depends}, xterm | x-terminal-emulator, x11-utils, menu (>= 2.1.9)
+Depends: ${misc:Depends}, ${shlibs:Depends}, xterm | x-terminal-emulator, x11-utils, menu
 Recommends: xfonts-75dpi | xfonts-75dpi-transcoded | xfonts-100dpi | xfonts-100dpi-transcoded, libxrandr2, libxinerama1
 Suggests: wmdocker
 Provides: x-window-manager, notion-api-${source:Upstream-Version}
@@ -28,7 +28,7 @@
 Package: notion-dev
 Section: devel
 Architecture: all
-Depends: ${misc:Depends}, libx11-dev, libsm-dev, lua5.3, gcc (>> 3)
+Depends: ${misc:Depends}, libx11-dev, libsm-dev, lua5.3, gcc
 Description: Notion development files
  Notion divides the screen into tiles and places windows in these tiles
  by default.  Each tile has a set of tabs for the windows within it.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

DPKG_EXPORT_BUILDTOOLS=1
-include /usr/share/dpkg/buildtools.mk
include /usr/share/dpkg/pkg-info.mk

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

# To fix https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=1097476
#   We define void (*destroy_fn)() and we call it with an argument
# The new default of c23 treats () as (void)
CFLAGS += -std=c17

# The upstream Makefiles do not look at CPPFLAGS. They should, and this should
# be unnecessary
override_dh_auto_build:
	NOTION_RELEASE=$(DEB_VERSION) CFLAGS="$(CFLAGS) $(CPPFLAGS)" dh_auto_build

override_dh_installman-arch:
	for langdir in debian/tmp/usr/share/man/*; do								\
		lang=`basename $$langdir`;									\
		test $$lang = "man1" || dh_installman --language $$lang debian/tmp/usr/share/man/$$lang/man1/*;	\
	done
	dh_installman --language C debian/tmp/usr/share/man/man1/* debian/install-notion-cfg.1

override_dh_installmenu-arch:
	dh_installmenu
	install -m644 debian/notion.menu-method.i18n \
		debian/notion/etc/menu-methods/notion-i18n

override_dh_install-indep:
	dh_install -i

	# install headers
	find . \( -name debian -o -name .pc -o -name config.h -o -name snprintf.h \) \
		-prune -o -name '*.h' -exec install -m644 -D {} \
		debian/notion-dev/usr/include/notion/{} \;

override_dh_install-arch:
	dh_install -a
	touch debian/notion/etc/X11/notion/cfg_debian_ext.lua


override_dh_fixperms-indep:
	dh_fixperms
	# this needs to be executable
	chmod a+x debian/notion-dev/usr/lib/notion/libextl/libextl-mkexports

# The manpages are build and moved to debian/tmp whether we're building arch-any
# packages or not. I don't want this to kill the build. Closes: 987507
override_dh_missing:
	dh_missing --list-missing

=== debian/watch ===
version=4
opts=dversionmangle=s/(?:\+dfsg|\+repack).*$//,\
filenamemangle=s/.+\/tcpflow-?(\d\S+)\.tar\.gz/$1\.tar\.gz/ \
  https://github.com/raboof/notion/tags .*/(\d\S+)\.tar\.gz
